---
title: XRSystem
slug: Web/API/XRSystem
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Interface
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSystem
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p class="summary"><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> interface <code><strong>XRSystem</strong></code> provides methods which let you get access to an {{domxref("XRSession")}} object representing a WebXR session. With that <code>XRSession</code> in hand, you can use it to interact with the Augmented Reality (AR) or Virtual Reality (VR) device.</span></p>

<h2 id="Properties">Properties</h2>

<p><em>While <code>XRSystem</code> directly offers no properties, it does inherit properties from its parent interface, {{domxref("EventTarget")}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>In addition to inheriting methods from its parent interface, {{domxref("EventTarget")}}, the <code>XRSystem</code> interface includes the following methods:</em></p>

<dl>
 <dt>{{DOMxRef("XRSystem.isSessionSupported", "isSessionSupported()")}} {{Experimental_Inline}}</dt>
 <dd>Returns a promise which resolves to <code>true</code> if the browser supports the given {{domxref("XRSessionMode")}}. Resolves to <code>false</code> if the specified mode isn't supported.</dd>
 <dt>{{DOMxRef("XRSystem.requestSession", "requestSession()")}} {{Experimental_Inline}}</dt>
 <dd>Returns a promise that resolves to a new {{DOMxRef("XRSession")}} with the specified {{DOMxRef("XRSessionMode")}}.</dd>
</dl>

<h2 id="Events">Events</h2>

<dl>
 <dt>{{domxref("XRSystem.devicechange_event", "devicechange")}} {{experimental_inline}}</dt>
 <dd>Sent when the set of available XR devices has changed.<br>
 Also available using the {{domxref("XRSystem.ondevicechange", "ondevicechange")}} event handler.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>This interface was previously known as <code>XR</code> in earlier versions of the specification; if you see references to <code>XR</code> in code or documentation, replace that with <code>XRSystem</code>.</p>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to use both {{domxref("XRSystem.isSessionSupported", "isSessionSupported()")}} and {{domxref("XRSystem.requestSession", "requestSession()")}}.</p>

<pre class="brush: js; notranslate">if (navigator.xr) {
  immersiveButton.addEventListener("click", onButtonClicked);
  navigator.xr.isSessionSupported('immersive-vr')
  .then((isSupported) =&gt; {
    if (isSupported) {
      immersiveButton.disabled = false;
    } else {
      immersiveButton.disabled = true;
    }
  });
}

function onButtonClicked() {
  if (!xrSession) {
    navigator.xr.requestSession('immersive-vr')
    .then((session) =&gt; {
      // onSessionStarted() not shown for reasons of brevity and clarity.
      onSessionStarted(session);
    });
  } else {
    // Shut down the already running XRSession
    xrSession.end()
    .then(() =&gt; {
      // Since there are cases where the end event is not sent, call the handler here as well.
      onSessionEnded();
    });
  }
}</pre>

<p>This code starts by checking to see if WebXR is available by looking for the {{domxref("navigator.xr")}} property. If it's found, we know WebXR is present, so we proceed by establishing a handler for the button which the user can click to toggle immersive VR mode on and off.</p>

<p>However, we don't yet know if the desired immersive mode is available. To determine this, we call <code>isSessionSupported()</code>, passing it the desired session option before enabling the button, <code>immersiveButton</code>, which the user can then use to switch to immersive mode only if immersive VR mode is available. If immersive VR isn't available, the button is disabled to prevent its use.</p>

<p>The <code>onButtonClicked()</code> function checks to see if there's already a session running. If there isn't, we use <code>requestSession()</code> to start one and, once the returned promise resolves, we call a function <code>onSessionStarted()</code> to set up our session for rendering and so forth.</p>

<p>If, on the other hand, there is already an ongoing XR session, we instead call {{domxref("XRSession.end", "end()")}} to end the current session. When the current session ends, the {{domxref("XRSession.end_event", "end")}} event is sent, so set <code>xrSession</code> to <code>null</code> in its handler to record the fact that we no longer have an ongoing session. That way, if the user clicks the button again, a new session will start.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR", "#xrsystem-interface", "XRSystem")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSystem")}}</div>
